Package com.xceptance.xlt.api.engine.scripting

# Interface ScriptCommands

All Known Implementing Classes:
  `AbstractWebDriverModule`, `AbstractWebDriverScriptTestCase`

public interface ScriptCommands
Selenium-like commands supported by the XLT framework and the script developer.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addSelection(String select, String option)`
  Adds the given option of the given select to the current selection.
  `void`
  `assertAttribute(String attributeLocator, String textPattern)`
  Asserts that the value of the attribute identified by the given attribute locator matches the given text pattern.
  `void`
  `assertAttribute(String elementLocator, String attributeName, String textPattern)`
  Asserts that the value of the attribute identified by the given element locator and attribute name matches the given text pattern.
  `void`
  `assertChecked(String elementLocator)`
  Asserts that the given checkbox/radio button is checked.
  `void`
  `assertClass(String elementLocator, String clazzString)`
  Asserts that the given element has the given class(es).
  `void`
  `assertElementCount(String elementLocator, int count)`
  Asserts that the number of elements found by using the given element locator is equal to the given count.
  `void`
  `assertElementCount(String elementLocator, String count)`
  Asserts that the number of elements found by using the given element locator is equal to the given count.
  `void`
  `assertElementPresent(String elementLocator)`
  Asserts that the given element is present.
  `void`
  `assertEval(String expression, String textPattern)`
  Asserts that evaluating the given expression matches the given text pattern.
  `void`
  `assertLoadTime(long loadTime)`
  Asserts that the time needed to load a page does not exceed the given value.
  `void`
  `assertLoadTime(String loadTime)`
  Asserts that the time needed to load a page does not exceed the given value.
  `void`
  `assertNotAttribute(String attributeLocator, String textPattern)`
  Asserts that the value of the attribute identified by the given attribute locator does NOT match the given text pattern.
  `void`
  `assertNotAttribute(String elementLocator, String attributeName, String textPattern)`
  Asserts that the value of the attribute identified by the given element locator and attribute name does NOT match the given text pattern.
  `void`
  `assertNotChecked(String elementLocator)`
  Asserts that the given checkbox/radio button is unchecked.
  `void`
  `assertNotClass(String elementLocator, String clazzString)`
  Asserts that the given element doesn't have the given class(es).
  `void`
  `assertNotElementCount(String elementLocator, int count)`
  Asserts that the number of elements found by using the given element locator is unequal to the given count.
  `void`
  `assertNotElementCount(String elementLocator, String count)`
  Asserts that the number of elements found by using the given element locator is unequal to the given count.
  `void`
  `assertNotElementPresent(String elementLocator)`
  Asserts that the given element is not present.
  `void`
  `assertNotEval(String expression, String textPattern)`
  Asserts that evaluating the given expression does NOT match the given text pattern.
  `void`
  `assertNotSelectedId(String selectLocator, String idPattern)`
  Asserts that no ID of all selected options of the given select element matches the given pattern.
  `void`
  `assertNotSelectedIndex(String selectLocator, String indexPattern)`
  Asserts that the option of the given select element at the given index is not selected.
  `void`
  `assertNotSelectedLabel(String selectLocator, String labelPattern)`
  Asserts that no label of all selected options of the given select element matches the given pattern.
  `void`
  `assertNotSelectedValue(String selectLocator, String valuePattern)`
  Asserts that no value of all selected options of the given select element matches the given pattern.
  `void`
  `assertNotStyle(String elementLocator, String styleText)`
  Asserts that the effective style of the element identified by the given element locator does NOT match the given style.
  `void`
  `assertNotText(String elementLocator, String text)`
  Asserts that the embedded text of the given element does not contain the given text.
  `void`
  `assertNotTextPresent(String text)`
  Asserts that the given text is not present on the page.
  `void`
  `assertNotTitle(String title)`
  Asserts that the page title does not match the given title.
  `void`
  `assertNotValue(String elementLocator, String valuePattern)`
  Asserts that the value of the given element doesn't match the given value.
  `void`
  `assertNotVisible(String elementLocator)`
  Asserts that the given element is invisible.
  `void`
  `assertNotXpathCount(String xpath, int count)`
  Asserts that the number of elements locatable by the given XPath expression is not equal to the given count.
  `void`
  `assertNotXpathCount(String xpath, String count)`
  Asserts that the number of elements locatable by the given XPath expression is not equal to the given count.
  `void`
  `assertPageSize(long pageSize)`
  Asserts that the size of the actual page (including images etc.) does not exceed the given value.
  `void`
  `assertPageSize(String pageSize)`
  Asserts that the size of the actual page (including images etc.) does not exceed the given value.
  `void`
  `assertSelectedId(String selectLocator, String idPattern)`
  Asserts that the ID of at least one selected option of the given select element matches the given pattern.
  `void`
  `assertSelectedIndex(String selectLocator, String indexPattern)`
  Asserts that the option of the given select element at the given index is selected.
  `void`
  `assertSelectedLabel(String selectLocator, String labelPattern)`
  Asserts that the label of at least one selected option of the given select element matches the given pattern.
  `void`
  `assertSelectedValue(String selectLocator, String valuePattern)`
  Asserts that the value of at least one selected option of the given select element matches the given pattern.
  `void`
  `assertStyle(String elementLocator, String styleText)`
  Asserts that the effective style of the element identified by the given element locator matches the given style.
  `void`
  `assertText(String elementLocator, String text)`
  Asserts that the text embedded by the given element contains the given text.
  `void`
  `assertTextPresent(String text)`
  Asserts that the given text is present.
  `void`
  `assertTitle(String title)`
  Asserts that the given title matches the page title.
  `void`
  `assertValue(String elementLocator, String valuePattern)`
  Asserts that the value of the given element matches the given value.
  `void`
  `assertVisible(String elementLocator)`
  Asserts that the given element is visible.
  `void`
  `assertXpathCount(String xpath, int count)`
  Asserts that the number of elements locatable by the given XPath expression is equal to the given count.
  `void`
  `assertXpathCount(String xpath, String count)`
  Asserts that the number of elements locatable by the given XPath expression is equal to the given count.
  `void`
  `check(String elementLocator)`
  Checks/toggles the given element.
  `void`
  `checkAndWait(String elementLocator)`
  Checks/toggles the given element and waits for some activity to complete.
  `void`
  `click(String elementLocator)`
  Clicks the given element.
  `void`
  `clickAndWait(String elementLocator)`
  Clicks the given element and waits for some activity to complete.
  `void`
  `close()`
  Closes the browser.
  `void`
  `contextMenu(String elementLocator)`
  Simulates a right-click on the given element.
  `void`
  `contextMenuAt(String elementLocator, int coordX, int coordY)`
  Simulates a right-click at the given coordinates (relative to the given element).
  `void`
  `contextMenuAt(String elementLocator, String coordinates)`
  Simulates a right-click at the given coordinates (relative to the given element).
  `void`
  `createCookie(String cookie)`
  Creates a new cookie.
  `void`
  `createCookie(String cookie, String options)`
  Creates a new cookie.
  `void`
  `deleteAllVisibleCookies()`
  Removes all cookies visible to the current page.
  `void`
  `deleteCookie(String name)`
  Removes the cookie with the specified name.
  `void`
  `deleteCookie(String name, String options)`
  Removes the cookie with the specified name.
  `void`
  `doubleClick(String elementLocator)`
  Double-clicks the given element.
  `void`
  `doubleClickAndWait(String elementLocator)`
  Double-clicks the given element and waits for some activity to complete.
  `void`
  `echo(String message)`
  Prints the given message to the log.
  `void`
  `mouseDown(String elementLocator)`
  Presses the left mouse button on an element, but does not release the button yet.
  `void`
  `mouseDownAt(String elementLocator, int coordX, int coordY)`
  Presses the left mouse button at the given coordinates (relative to the given element), but does not release the button yet.
  `void`
  `mouseDownAt(String elementLocator, String coordinates)`
  Presses the left mouse button at the given coordinates (relative to the given element), but does not release the button yet.
  `void`
  `mouseMove(String elementLocator)`
  Moves the mouse to the given element.
  `void`
  `mouseMoveAt(String elementLocator, int coordX, int coordY)`
  Moves the mouse to the given coordinates (relative to the given element).
  `void`
  `mouseMoveAt(String elementLocator, String coordinates)`
  Moves the mouse to the given coordinates (relative to the given element).
  `void`
  `mouseOut(String elementLocator)`
  Moves the mouse out of the element's bounding box.
  `void`
  `mouseOver(String elementLocator)`
  Hovers the mouse over an element.
  `void`
  `mouseUp(String elementLocator)`
  Releases the left mouse button on an element.
  `void`
  `mouseUpAt(String elementLocator, int coordX, int coordY)`
  Releases the left mouse button at the given coordinates (relative to the given element).
  `void`
  `mouseUpAt(String elementLocator, String coordinates)`
  Releases the left mouse button at the given coordinates (relative to the given element).
  `void`
  `open(String pageUrlString)`
  Opens the given URL.
  `void`
  `pause(long waitingTime)`
  Waits the given time.
  `void`
  `pause(String waitingTime)`
  Waits the given time.
  `void`
  `removeSelection(String select, String option)`
  Removes the given option of the given select from the current selection.
  `void`
  `select(String select, String option)`
  Selects the given option of the given select.
  `void`
  `selectAndWait(String select, String option)`
  Selects the given option of the given select and waits for some activity to complete.
  `void`
  `selectFrame(String frameTarget)`
  Selects the given frame.
  `void`
  `selectWindow()`
  Selects the top-level window.
  `void`
  `selectWindow(String windowTarget)`
  Selects the given window.
  `void`
  `setTimeout(long timeout)`
  Sets the timeout to the given value.
  `void`
  `setTimeout(String timeout)`
  Sets the timeout to the given value.
  `void`
  `startAction(String actionName)`
  Starts a new action using the given name.
  `void`
  `store(String text, String variableName)`
  Stores the given text to the given variable.
  `void`
  `storeAttribute(String attributeLocator, String variableName)`
  Stores the value of the attribute identified by the given attribute locator to the given variable
  `void`
  `storeAttribute(String elementLocator, String attributeName, String variableName)`
  Stores the value of the given element and attribute to the given variable.
  `void`
  `storeElementCount(String elementLocator, String variableName)`
  Stores that the number of elements found by using the given element locator to the given variable.
  `void`
  `storeEval(String expression, String variableName)`
  Stores the result of evaluating the given expression to the given variable.
  `void`
  `storeText(String elementLocator, String variableName)`
  Stores the text of the element identified by the given locator to the given variable.
  `void`
  `storeTitle(String variableName)`
  Stores the title of the currently active document to the given variable.
  `void`
  `storeValue(String elementLocator, String variableName)`
  Stores the value (in case of a `<textarea>` the contained text) of the element identified by the given locator to the given variable.
  `void`
  `storeXpathCount(String xpath, String variableName)`
  Stores the number of elements matching the given XPath expression to the given variable.
  `void`
  `submit(String form)`
  Submits the given form.
  `void`
  `submitAndWait(String form)`
  Submits the given form and waits for some activity to complete.
  `void`
  `type(String elementLocator, String text)`
  Types the given text into the given input field.
  `void`
  `typeAndWait(String elementLocator, String text)`
  Types the given text into the given input field and waits for some activity to complete.
  `void`
  `uncheck(String elementLocator)`
  Unchecks the given checkbox/radio button.
  `void`
  `uncheckAndWait(String elementLocator)`
  Unchecks the given checkbox/radio button and waits for a page load.
  `void`
  `waitForAttribute(String attributeLocator, String textPattern)`
  Waits until the value of the attribute identified by the given attribute locator matches the given text pattern.
  `void`
  `waitForAttribute(String elementLocator, String attributeName, String textPattern)`
  Waits until the value of the given element and attribute matches the given text pattern.
  `void`
  `waitForChecked(String elementLocator)`
  Waits until the given checkbox/radio button becomes checked.
  `void`
  `waitForClass(String elementLocator, String clazzString)`
  Waits until the given element has the given class(es).
  `void`
  `waitForElementCount(String elementLocator, int count)`
  Waits until the number of elements found by using the given element locator is equal to the given count.
  `void`
  `waitForElementCount(String elementLocator, String count)`
  Waits until the number of elements found by using the given element locator is equal to the given count.
  `void`
  `waitForElementPresent(String elementLocator)`
  Waits for the given element to appear.
  `void`
  `waitForEval(String expression, String textPattern)`
  Waits until the result of evaluating the given expression matches the given text pattern.
  `void`
  `waitForNotAttribute(String attributeLocator, String textPattern)`
  Waits until the value of the attribute identified by the given attribute locator does NOT match the given text pattern.
  `void`
  `waitForNotAttribute(String elementLocator, String attributeName, String textPattern)`
  Waits until the value of the given element and attribute does NOT match the given text pattern.
  `void`
  `waitForNotChecked(String elementLocator)`
  Waits until the given checkbox/radio button becomes unchecked.
  `void`
  `waitForNotClass(String elementLocator, String clazzString)`
  Waits until the given element doesn't have the given class(es).
  `void`
  `waitForNotElementCount(String elementLocator, int count)`
  Waits until the number of elements found by using the given element locator is unequal to the given count.
  `void`
  `waitForNotElementCount(String elementLocator, String count)`
  Waits until the number of elements found by using the given element locator is unequal to the given count.
  `void`
  `waitForNotElementPresent(String elementLocator)`
  Waits for the given element to disappear.
  `void`
  `waitForNotEval(String expression, String textPattern)`
  Waits until the result of evaluating the given expression does NOT match the given text pattern.
  `void`
  `waitForNotSelectedId(String selectLocator, String idPattern)`
  Waits until no ID of all selected options of the given select matches the given pattern.
  `void`
  `waitForNotSelectedIndex(String selectLocator, String indexPattern)`
  Waits until the option of the given select element at the given index is not selected.
  `void`
  `waitForNotSelectedLabel(String selectLocator, String labelPattern)`
  Waits until no label of all selected options of the given select matches the given pattern.
  `void`
  `waitForNotSelectedValue(String selectLocator, String valuePattern)`
  Waits until no value of all selected options of the given select matches the given pattern.
  `void`
  `waitForNotStyle(String elementLocator, String styleText)`
  Waits until the effective style of the element identified by the given element locator does NOT match the given style.
  `void`
  `waitForNotText(String elementLocator, String text)`
  Waits for the given text embedded in the given element to disappear/change.
  `void`
  `waitForNotTextPresent(String text)`
  Waits for the given text to disappear/change.
  `void`
  `waitForNotTitle(String title)`
  Waits for the given page title change.
  `void`
  `waitForNotValue(String elementLocator, String value)`
  Waits for the given value in the given element to disappear/change.
  `void`
  `waitForNotVisible(String elementLocator)`
  Waits until the given element becomes invisible.
  `void`
  `waitForNotXpathCount(String xpath, int count)`
  Waits for the number of elements matching the given XPath expression change to a different value than the given one.
  `void`
  `waitForNotXpathCount(String xpath, String count)`
  Waits for the number of elements matching the given XPath expression change to a different value than the given one.
  `void`
  `waitForPageToLoad()`
  Waits for the page to be loaded completely.
  `void`
  `waitForPopUp()`
  Waits for any pop-up window to be loaded completely.
  `void`
  `waitForPopUp(String windowID)`
  Waits for some pop-up window to be loaded completely.
  `void`
  `waitForPopUp(String windowID, long maxWaitingTime)`
  Waits at most the given time for some pop-up window to be loaded completely.
  `void`
  `waitForPopUp(String windowID, String maxWaitingTime)`
  Waits at most the given time for some pop-up window to be loaded completely.
  `void`
  `waitForSelectedId(String selectLocator, String idPattern)`
  Waits until the ID of at least one selected option of the given select matches the given pattern.
  `void`
  `waitForSelectedIndex(String selectLocator, String indexPattern)`
  Waits until the option of the given select at the given index is selected.
  `void`
  `waitForSelectedLabel(String selectLocator, String labelPattern)`
  Waits until the label of at least one selected option of the given select matches the given pattern.
  `void`
  `waitForSelectedValue(String selectLocator, String valuePattern)`
  Waits until the value of at least one selected option of the given select matches the given pattern.
  `void`
  `waitForStyle(String elementLocator, String styleText)`
  Waits until the effective style of the element identified by the given element locator matches the given style.
  `void`
  `waitForText(String elementLocator, String text)`
  Waits for the given text embedded in the given element.
  `void`
  `waitForTextPresent(String text)`
  Waits for the given text to appear.
  `void`
  `waitForTitle(String title)`
  Waits for the given page title.
  `void`
  `waitForValue(String elementLocator, String value)`
  Waits for the given value in the given element.
  `void`
  `waitForVisible(String elementLocator)`
  Waits until the given element becomes visible.
  `void`
  `waitForXpathCount(String xpath, int count)`
  Waits for the number of elements matching the given XPath expression is equal to the given count.
  `void`
  `waitForXpathCount(String xpath, String count)`
  Waits for the number of elements matching the given XPath expression is equal to the given count.

- ## Method Details

  - ### addSelection

    void addSelection(String select, String option)
    Adds the given option of the given select to the current selection.
    Parameters:
      `select` - the select
      `option` - the option to be added to current selection

  - ### assertAttribute

    void assertAttribute(String attributeLocator, String textPattern)
    Asserts that the value of the attribute identified by the given attribute locator matches the given text pattern.
    Parameters:
      `attributeLocator` - the attribute locator
      `textPattern` - the text pattern that the attribute value must match

  - ### assertAttribute

    void assertAttribute(String elementLocator, String attributeName, String textPattern)
    Asserts that the value of the attribute identified by the given element locator and attribute name matches the given text pattern.
    Parameters:
      `elementLocator` - the element locator
      `attributeName` - the name of the attribute
      `textPattern` - the text pattern that the attribute value must match

  - ### assertChecked

    void assertChecked(String elementLocator)
    Asserts that the given checkbox/radio button is checked.
    Parameters:
      `elementLocator` - the checkbox/radio button element locator

  - ### assertClass

    void assertClass(String elementLocator, String clazzString)
    Asserts that the given element has the given class(es).
    Parameters:
      `elementLocator` - the element locator
      `clazzString` - the class(es) string

  - ### assertElementCount

    void assertElementCount(String elementLocator, int count)
    Asserts that the number of elements found by using the given element locator is equal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### assertElementCount

    void assertElementCount(String elementLocator, String count)
    Asserts that the number of elements found by using the given element locator is equal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### assertElementPresent

    void assertElementPresent(String elementLocator)
    Asserts that the given element is present.
    Parameters:
      `elementLocator` - locator identifying the element that should be present

  - ### assertEval

    void assertEval(String expression, String textPattern)
    Asserts that evaluating the given expression matches the given text pattern.
    Parameters:
      `expression` - the expression to evaluate
      `textPattern` - the text pattern that the evaluation result must match

  - ### assertLoadTime

    void assertLoadTime(long loadTime)
    Asserts that the time needed to load a page does not exceed the given value.
    Parameters:
      `loadTime` - maximum load time in milliseconds

  - ### assertLoadTime

    void assertLoadTime(String loadTime)
    Asserts that the time needed to load a page does not exceed the given value.
    Parameters:
      `loadTime` - maximum load time in milliseconds

  - ### assertNotAttribute

    void assertNotAttribute(String attributeLocator, String textPattern)
    Asserts that the value of the attribute identified by the given attribute locator does NOT match the given text pattern.
    Parameters:
      `attributeLocator` - the attribute locator
      `textPattern` - the text pattern that the attribute value must NOT match

  - ### assertNotAttribute

    void assertNotAttribute(String elementLocator, String attributeName, String textPattern)
    Asserts that the value of the attribute identified by the given element locator and attribute name does NOT match the given text pattern.
    Parameters:
      `elementLocator` - the element locator
      `attributeName` - the name of the attribute
      `textPattern` - the text pattern that the attribute value must NOT match

  - ### assertNotChecked

    void assertNotChecked(String elementLocator)
    Asserts that the given checkbox/radio button is unchecked.
    Parameters:
      `elementLocator` - the checkbox/radio button element locator

  - ### assertNotClass

    void assertNotClass(String elementLocator, String clazzString)
    Asserts that the given element doesn't have the given class(es).
    Parameters:
      `elementLocator` - the element locator
      `clazzString` - the class(es) string

  - ### assertNotElementCount

    void assertNotElementCount(String elementLocator, int count)
    Asserts that the number of elements found by using the given element locator is unequal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### assertNotElementCount

    void assertNotElementCount(String elementLocator, String count)
    Asserts that the number of elements found by using the given element locator is unequal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### assertNotElementPresent

    void assertNotElementPresent(String elementLocator)
    Asserts that the given element is not present.
    Parameters:
      `elementLocator` - locator identifying the element that should be NOT present

  - ### assertNotEval

    void assertNotEval(String expression, String textPattern)
    Asserts that evaluating the given expression does NOT match the given text pattern.
    Parameters:
      `expression` - the expression to evaluate
      `textPattern` - the text pattern that the evaluation result must NOT match

  - ### assertNotSelectedId

    void assertNotSelectedId(String selectLocator, String idPattern)
    Asserts that no ID of all selected options of the given select element matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `idPattern` - the ID pattern

  - ### assertNotSelectedIndex

    void assertNotSelectedIndex(String selectLocator, String indexPattern)
    Asserts that the option of the given select element at the given index is not selected.
    Parameters:
      `selectLocator` - the select element locator
      `indexPattern` - the option index pattern

  - ### assertNotSelectedLabel

    void assertNotSelectedLabel(String selectLocator, String labelPattern)
    Asserts that no label of all selected options of the given select element matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `labelPattern` - the label pattern

  - ### assertNotSelectedValue

    void assertNotSelectedValue(String selectLocator, String valuePattern)
    Asserts that no value of all selected options of the given select element matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `valuePattern` - the value pattern

  - ### assertNotStyle

    void assertNotStyle(String elementLocator, String styleText)
    Asserts that the effective style of the element identified by the given element locator does NOT match the given style.
    Parameters:
      `elementLocator` - the element locator
      `styleText` - the style that must NOT match (e.g. `width: 10px; overflow: hidden;`)

  - ### assertNotText

    void assertNotText(String elementLocator, String text)
    Asserts that the embedded text of the given element does not contain the given text.
    Parameters:
      `elementLocator` - locator identifying the element
      `text` - the text that should not be embedded in the given element

  - ### assertNotTextPresent

    void assertNotTextPresent(String text)
    Asserts that the given text is not present on the page.
    Parameters:
      `text` - the text that should NOT be present

  - ### assertNotTitle

    void assertNotTitle(String title)
    Asserts that the page title does not match the given title.
    Parameters:
      `title` - the title that should not match

  - ### assertNotValue

    void assertNotValue(String elementLocator, String valuePattern)
    Asserts that the value of the given element doesn't match the given value. If the element is a <textarea> this method asserts that the containing text doesn't match the given value.
    Parameters:
      `elementLocator` - locator identifying the element whose value doesn't match the given value
      `valuePattern` - the value that doesn't match the given element's value

  - ### assertNotVisible

    void assertNotVisible(String elementLocator)
    Asserts that the given element is invisible.
    Parameters:
      `elementLocator` - the element locator.

  - ### assertNotXpathCount

    void assertNotXpathCount(String xpath, int count)
    Asserts that the number of elements locatable by the given XPath expression is not equal to the given count.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements that should NOT be equal to the actual number of elements matching the given XPath expression

  - ### assertNotXpathCount

    void assertNotXpathCount(String xpath, String count)
    Asserts that the number of elements locatable by the given XPath expression is not equal to the given count.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements that should NOT be equal to the actual number of elements matching the given XPath expression

  - ### assertPageSize

    void assertPageSize(long pageSize)
    Asserts that the size of the actual page (including images etc.) does not exceed the given value.
    Parameters:
      `pageSize` - the number of bytes the page size must not exceed

  - ### assertPageSize

    void assertPageSize(String pageSize)
    Asserts that the size of the actual page (including images etc.) does not exceed the given value.
    Parameters:
      `pageSize` - the number of bytes the page size must not exceed

  - ### assertSelectedId

    void assertSelectedId(String selectLocator, String idPattern)
    Asserts that the ID of at least one selected option of the given select element matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `idPattern` - ID pattern

  - ### assertSelectedIndex

    void assertSelectedIndex(String selectLocator, String indexPattern)
    Asserts that the option of the given select element at the given index is selected.
    Parameters:
      `selectLocator` - the select element locator
      `indexPattern` - the option index pattern

  - ### assertSelectedLabel

    void assertSelectedLabel(String selectLocator, String labelPattern)
    Asserts that the label of at least one selected option of the given select element matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `labelPattern` - the label pattern

  - ### assertSelectedValue

    void assertSelectedValue(String selectLocator, String valuePattern)
    Asserts that the value of at least one selected option of the given select element matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `valuePattern` - the value pattern

  - ### assertStyle

    void assertStyle(String elementLocator, String styleText)
    Asserts that the effective style of the element identified by the given element locator matches the given style.
    Parameters:
      `elementLocator` - the element locator
      `styleText` - the style to match (e.g. `width: 10px; overflow: hidden;`)

  - ### assertText

    void assertText(String elementLocator, String text)
    Asserts that the text embedded by the given element contains the given text.
    Parameters:
      `elementLocator` - locator identifying the element whose text should contain the given text
      `text` - the text that should be embedded in the given element

  - ### assertTextPresent

    void assertTextPresent(String text)
    Asserts that the given text is present.
    Parameters:
      `text` - the text that should be present

  - ### assertTitle

    void assertTitle(String title)
    Asserts that the given title matches the page title.
    Parameters:
      `title` - the title that should match the page title

  - ### assertValue

    void assertValue(String elementLocator, String valuePattern)
    Asserts that the value of the given element matches the given value. If the element is a <textarea> this method asserts that the containing text matches the given value.
    Parameters:
      `elementLocator` - locator identifying the element whose value should match the given value
      `valuePattern` - the value that should match the given element's value

  - ### assertVisible

    void assertVisible(String elementLocator)
    Asserts that the given element is visible.
    Parameters:
      `elementLocator` - the element locator

  - ### assertXpathCount

    void assertXpathCount(String xpath, int count)
    Asserts that the number of elements locatable by the given XPath expression is equal to the given count.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements that must match the given XPath expression

  - ### assertXpathCount

    void assertXpathCount(String xpath, String count)
    Asserts that the number of elements locatable by the given XPath expression is equal to the given count.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements that must match the given XPath expression

  - ### check

    void check(String elementLocator)
    Checks/toggles the given element.
    Parameters:
      `elementLocator` - locator identifying the element to be checked/toggled

  - ### checkAndWait

    void checkAndWait(String elementLocator)
    Checks/toggles the given element and waits for some activity to complete.
    Parameters:
      `elementLocator` - locator identifying the element to be checked/toggled

  - ### click

    void click(String elementLocator)
    Clicks the given element.
    Parameters:
      `elementLocator` - locator identifying the element to be clicked.

  - ### clickAndWait

    void clickAndWait(String elementLocator)
    Clicks the given element and waits for some activity to complete.
    Parameters:
      `elementLocator` - locator identifying the element to be clicked

  - ### close

    void close()
    Closes the browser.

  - ### contextMenu

    void contextMenu(String elementLocator)
    Simulates a right-click on the given element.
    Parameters:
      `elementLocator` - locator identifying the element to fire events at

  - ### contextMenuAt

    void contextMenuAt(String elementLocator, String coordinates)
    Simulates a right-click at the given coordinates (relative to the given element).
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordinates` - the coordinates relative to the given element

  - ### contextMenuAt

    void contextMenuAt(String elementLocator, int coordX, int coordY)
    Simulates a right-click at the given coordinates (relative to the given element).
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordX` - the X coordinate relative to the given element
      `coordY` - the Y coordinate relative to the given element

  - ### createCookie

    void createCookie(String cookie)
    Creates a new cookie. The new cookie will be stored as session cookie for the current path and domain.
    Parameters:
      `cookie` - name value pair of the new cookie

  - ### createCookie

    void createCookie(String cookie, String options)
    Creates a new cookie.
    Parameters:
      `cookie` - name value pair of the new cookie
      `options` - cookie creation options (path, max_age and domain)

  - ### deleteAllVisibleCookies

    void deleteAllVisibleCookies()
    Removes all cookies visible to the current page.

  - ### deleteCookie

    void deleteCookie(String name)
    Removes the cookie with the specified name.
    Parameters:
      `name` - the cookie's name

  - ### deleteCookie

    void deleteCookie(String name, String options)
    Removes the cookie with the specified name.
    Parameters:
      `name` - the cookie's name
      `options` - cookie removal options (path, domain and recurse)

  - ### doubleClick

    void doubleClick(String elementLocator)
    Double-clicks the given element.
    Parameters:
      `elementLocator` - locator identifying the element to be double-clicked

  - ### doubleClickAndWait

    void doubleClickAndWait(String elementLocator)
    Double-clicks the given element and waits for some activity to complete.
    Parameters:
      `elementLocator` - locator identifying the element to be double-clicked

  - ### echo

    void echo(String message)
    Prints the given message to the log.
    Parameters:
      `message` - the message to print

  - ### mouseDown

    void mouseDown(String elementLocator)
    Presses the left mouse button on an element, but does not release the button yet.
    Parameters:
      `elementLocator` - locator identifying the target element

  - ### mouseDownAt

    void mouseDownAt(String elementLocator, String coordinates)
    Presses the left mouse button at the given coordinates (relative to the given element), but does not release the button yet.
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordinates` - the coordinates relative to the given element

  - ### mouseDownAt

    void mouseDownAt(String elementLocator, int coordX, int coordY)
    Presses the left mouse button at the given coordinates (relative to the given element), but does not release the button yet.
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordX` - the X coordinate relative to the given element
      `coordY` - the Y coordinate relative to the given element

  - ### mouseMove

    void mouseMove(String elementLocator)
    Moves the mouse to the given element.
    Parameters:
      `elementLocator` - locator identifying the target element

  - ### mouseMoveAt

    void mouseMoveAt(String elementLocator, String coordinates)
    Moves the mouse to the given coordinates (relative to the given element).
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordinates` - the coordinates relative to the given element

  - ### mouseMoveAt

    void mouseMoveAt(String elementLocator, int coordX, int coordY)
    Moves the mouse to the given coordinates (relative to the given element).
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordX` - the X coordinate relative to the given element
      `coordY` - the Y coordinate relative to the given element

  - ### mouseOut

    void mouseOut(String elementLocator)
    Moves the mouse out of the element's bounding box.
    Parameters:
      `elementLocator` - locator identifying the target element

  - ### mouseOver

    void mouseOver(String elementLocator)
    Hovers the mouse over an element.
    Parameters:
      `elementLocator` - locator identifying the target element

  - ### mouseUp

    void mouseUp(String elementLocator)
    Releases the left mouse button on an element.
    Parameters:
      `elementLocator` - locator identifying the target element

  - ### mouseUpAt

    void mouseUpAt(String elementLocator, String coordinates)
    Releases the left mouse button at the given coordinates (relative to the given element).
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordinates` - the coordinates relative to the given element

  - ### mouseUpAt

    void mouseUpAt(String elementLocator, int coordX, int coordY)
    Releases the left mouse button at the given coordinates (relative to the given element).
    Parameters:
      `elementLocator` - locator identifying the target element
      `coordX` - the X coordinate relative to the given element
      `coordY` - the Y coordinate relative to the given element

  - ### open

    void open(String pageUrlString)
    Opens the given URL.
    Parameters:
      `pageUrlString` - the URL to open

  - ### pause

    void pause(long waitingTime)
    Waits the given time.
    Parameters:
      `waitingTime` - the time in milliseconds to wait

  - ### pause

    void pause(String waitingTime)
    Waits the given time.
    Parameters:
      `waitingTime` - the time in milliseconds to wait

  - ### removeSelection

    void removeSelection(String select, String option)
    Removes the given option of the given select from the current selection.
    Parameters:
      `select` - the select
      `option` - the option to be removed from the current selection

  - ### select

    void select(String select, String option)
    Selects the given option of the given select.
    Parameters:
      `select` - the select
      `option` - the option to select

  - ### selectAndWait

    void selectAndWait(String select, String option)
    Selects the given option of the given select and waits for some activity to complete.
    Parameters:
      `select` - the select
      `option` - the option to select

  - ### selectFrame

    void selectFrame(String frameTarget)
    Selects the given frame.
    Parameters:
      `frameTarget` - the frame to be selected

  - ### selectWindow

    void selectWindow()
    Selects the top-level window.

  - ### selectWindow

    void selectWindow(String windowTarget)
    Selects the given window.
    Parameters:
      `windowTarget` - the window to be selected

  - ### setTimeout

    void setTimeout(long timeout)
    Sets the timeout to the given value.
    Parameters:
      `timeout` - the new timeout in milliseconds

  - ### setTimeout

    void setTimeout(String timeout)
    Sets the timeout to the given value.
    Parameters:
      `timeout` - the new timeout in milliseconds

  - ### startAction

    void startAction(String actionName)
    Starts a new action using the given name.
    Parameters:
      `actionName` - the name of the action

  - ### store

    void store(String text, String variableName)
    Stores the given text to the given variable.
    Parameters:
      `text` - the text to store
      `variableName` - the variable name

  - ### storeAttribute

    void storeAttribute(String attributeLocator, String variableName)
    Stores the value of the attribute identified by the given attribute locator to the given variable
    Parameters:
      `attributeLocator` - the attribute locator
      `variableName` - the variable name

  - ### storeAttribute

    void storeAttribute(String elementLocator, String attributeName, String variableName)
    Stores the value of the given element and attribute to the given variable.
    Parameters:
      `elementLocator` - the element locator
      `attributeName` - the name of the attribute
      `variableName` - the variable name

  - ### storeElementCount

    void storeElementCount(String elementLocator, String variableName)
    Stores that the number of elements found by using the given element locator to the given variable.
    Parameters:
      `elementLocator` - the element locator
      `variableName` - the variable name

  - ### storeEval

    void storeEval(String expression, String variableName)
    Stores the result of evaluating the given expression to the given variable.
    Parameters:
      `expression` - the expression to evaluate
      `variableName` - the variable name

  - ### storeText

    void storeText(String elementLocator, String variableName)
    Stores the text of the element identified by the given locator to the given variable.
    Parameters:
      `elementLocator` - the element locator
      `variableName` - the variable

  - ### storeTitle

    void storeTitle(String variableName)
    Stores the title of the currently active document to the given variable.
    Parameters:
      `variableName` - the variable

  - ### storeValue

    void storeValue(String elementLocator, String variableName)
    Stores the value (in case of a `<textarea>` the contained text) of the element identified by the given locator to the given variable.
    Parameters:
      `elementLocator` - the element locator
      `variableName` - the variable

  - ### storeXpathCount

    void storeXpathCount(String xpath, String variableName)
    Stores the number of elements matching the given XPath expression to the given variable.
    Parameters:
      `xpath` - the XPath expression
      `variableName` - the variable

  - ### submit

    void submit(String form)
    Submits the given form.
    Parameters:
      `form` - the form to submit

  - ### submitAndWait

    void submitAndWait(String form)
    Submits the given form and waits for some activity to complete.
    Parameters:
      `form` - the form to submit

  - ### type

    void type(String elementLocator, String text)
    Types the given text into the given input field.
    Parameters:
      `elementLocator` - locator identifying the input field
      `text` - the text to be typed

  - ### typeAndWait

    void typeAndWait(String elementLocator, String text)
    Types the given text into the given input field and waits for some activity to complete.
    Parameters:
      `elementLocator` - locator identifying the input field
      `text` - the text to be typed

  - ### uncheck

    void uncheck(String elementLocator)
    Unchecks the given checkbox/radio button.
    Parameters:
      `elementLocator` - locator identifying the checkbox/radio button

  - ### uncheckAndWait

    void uncheckAndWait(String elementLocator)
    Unchecks the given checkbox/radio button and waits for a page load.
    Parameters:
      `elementLocator` - locator identifying the checkbox/radio button

  - ### waitForAttribute

    void waitForAttribute(String attributeLocator, String textPattern)
    Waits until the value of the attribute identified by the given attribute locator matches the given text pattern.
    Parameters:
      `attributeLocator` - the attribute locator
      `textPattern` - the text pattern

  - ### waitForAttribute

    void waitForAttribute(String elementLocator, String attributeName, String textPattern)
    Waits until the value of the given element and attribute matches the given text pattern.
    Parameters:
      `elementLocator` - the element locator
      `attributeName` - the name of the attribute
      `textPattern` - the text pattern

  - ### waitForChecked

    void waitForChecked(String elementLocator)
    Waits until the given checkbox/radio button becomes checked.
    Parameters:
      `elementLocator` - the checkbox/radio button element locator

  - ### waitForClass

    void waitForClass(String elementLocator, String clazzString)
    Waits until the given element has the given class(es).
    Parameters:
      `elementLocator` - the element locator
      `clazzString` - the class(es) string

  - ### waitForElementCount

    void waitForElementCount(String elementLocator, int count)
    Waits until the number of elements found by using the given element locator is equal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### waitForElementCount

    void waitForElementCount(String elementLocator, String count)
    Waits until the number of elements found by using the given element locator is equal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### waitForElementPresent

    void waitForElementPresent(String elementLocator)
    Waits for the given element to appear.
    Parameters:
      `elementLocator` - locator identifying the element to wait for

  - ### waitForEval

    void waitForEval(String expression, String textPattern)
    Waits until the result of evaluating the given expression matches the given text pattern.
    Parameters:
      `expression` - the expression to evaluate
      `textPattern` - textPattern the text pattern the evaluation result must match

  - ### waitForNotAttribute

    void waitForNotAttribute(String attributeLocator, String textPattern)
    Waits until the value of the attribute identified by the given attribute locator does NOT match the given text pattern.
    Parameters:
      `attributeLocator` - the attribute locator
      `textPattern` - the text pattern that must NOT match

  - ### waitForNotAttribute

    void waitForNotAttribute(String elementLocator, String attributeName, String textPattern)
    Waits until the value of the given element and attribute does NOT match the given text pattern.
    Parameters:
      `elementLocator` - the element locator
      `attributeName` - the name of the attribute
      `textPattern` - the text pattern

  - ### waitForNotChecked

    void waitForNotChecked(String elementLocator)
    Waits until the given checkbox/radio button becomes unchecked.
    Parameters:
      `elementLocator` - the checkbox/radio button element locator

  - ### waitForNotClass

    void waitForNotClass(String elementLocator, String clazzString)
    Waits until the given element doesn't have the given class(es).
    Parameters:
      `elementLocator` - the element locator
      `clazzString` - the class(es) string

  - ### waitForNotElementCount

    void waitForNotElementCount(String elementLocator, int count)
    Waits until the number of elements found by using the given element locator is unequal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### waitForNotElementCount

    void waitForNotElementCount(String elementLocator, String count)
    Waits until the number of elements found by using the given element locator is unequal to the given count.
    Parameters:
      `elementLocator` - the element locator
      `count` - the number of elements

  - ### waitForNotElementPresent

    void waitForNotElementPresent(String elementLocator)
    Waits for the given element to disappear.
    Parameters:
      `elementLocator` - locator identifying the element to disappear

  - ### waitForNotEval

    void waitForNotEval(String expression, String textPattern)
    Waits until the result of evaluating the given expression does NOT match the given text pattern.
    Parameters:
      `expression` - the expression to evaluate
      `textPattern` - the text pattern that the evaluation result must NOT match

  - ### waitForNotSelectedId

    void waitForNotSelectedId(String selectLocator, String idPattern)
    Waits until no ID of all selected options of the given select matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `idPattern` - the ID pattern

  - ### waitForNotSelectedIndex

    void waitForNotSelectedIndex(String selectLocator, String indexPattern)
    Waits until the option of the given select element at the given index is not selected.
    Parameters:
      `selectLocator` - the select element locator
      `indexPattern` - the option index pattern

  - ### waitForNotSelectedLabel

    void waitForNotSelectedLabel(String selectLocator, String labelPattern)
    Waits until no label of all selected options of the given select matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `labelPattern` - the label pattern

  - ### waitForNotSelectedValue

    void waitForNotSelectedValue(String selectLocator, String valuePattern)
    Waits until no value of all selected options of the given select matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `valuePattern` - the value pattern

  - ### waitForNotStyle

    void waitForNotStyle(String elementLocator, String styleText)
    Waits until the effective style of the element identified by the given element locator does NOT match the given style.
    Parameters:
      `elementLocator` - the element locator
      `styleText` - the style that must NOT match (e.g. `width: 10px; overflow: hidden;`)

  - ### waitForNotText

    void waitForNotText(String elementLocator, String text)
    Waits for the given text embedded in the given element to disappear/change.
    Parameters:
      `elementLocator` - locator identifying the element whose embedded text should change
      `text` - the text that should change/disappear

  - ### waitForNotTextPresent

    void waitForNotTextPresent(String text)
    Waits for the given text to disappear/change.
    Parameters:
      `text` - the text that should disappear/change

  - ### waitForNotTitle

    void waitForNotTitle(String title)
    Waits for the given page title change.
    Parameters:
      `title` - the page title that should change

  - ### waitForNotValue

    void waitForNotValue(String elementLocator, String value)
    Waits for the given value in the given element to disappear/change.
    Parameters:
      `elementLocator` - locator identifying the element whose value should change
      `value` - the value that should change/disappear

  - ### waitForNotVisible

    void waitForNotVisible(String elementLocator)
    Waits until the given element becomes invisible.
    Parameters:
      `elementLocator` - the element locator

  - ### waitForNotXpathCount

    void waitForNotXpathCount(String xpath, int count)
    Waits for the number of elements matching the given XPath expression change to a different value than the given one.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements currently matching the given XPath expression

  - ### waitForNotXpathCount

    void waitForNotXpathCount(String xpath, String count)
    Waits for the number of elements matching the given XPath expression change to a different value than the given one.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements currently matching the given XPath expression

  - ### waitForPageToLoad

    void waitForPageToLoad()
    Waits for the page to be loaded completely.

  - ### waitForPopUp

    void waitForPopUp()
    Waits for any pop-up window to be loaded completely.

  - ### waitForPopUp

    void waitForPopUp(String windowID)
    Waits for some pop-up window to be loaded completely.
    Parameters:
      `windowID` - the ID of the window to wait for

  - ### waitForPopUp

    void waitForPopUp(String windowID, long maxWaitingTime)
    Waits at most the given time for some pop-up window to be loaded completely.
    Parameters:
      `windowID` - the ID of the window to wait for
      `maxWaitingTime` - the maximum waiting time

  - ### waitForPopUp

    void waitForPopUp(String windowID, String maxWaitingTime)
    Waits at most the given time for some pop-up window to be loaded completely.
    Parameters:
      `windowID` - the ID of the window to wait for
      `maxWaitingTime` - the maximum waiting time

  - ### waitForSelectedId

    void waitForSelectedId(String selectLocator, String idPattern)
    Waits until the ID of at least one selected option of the given select matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `idPattern` - the ID pattern

  - ### waitForSelectedIndex

    void waitForSelectedIndex(String selectLocator, String indexPattern)
    Waits until the option of the given select at the given index is selected.
    Parameters:
      `selectLocator` - the select element locator
      `indexPattern` - the option index pattern

  - ### waitForSelectedLabel

    void waitForSelectedLabel(String selectLocator, String labelPattern)
    Waits until the label of at least one selected option of the given select matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `labelPattern` - the label pattern

  - ### waitForSelectedValue

    void waitForSelectedValue(String selectLocator, String valuePattern)
    Waits until the value of at least one selected option of the given select matches the given pattern.
    Parameters:
      `selectLocator` - the select element locator
      `valuePattern` - the value pattern

  - ### waitForStyle

    void waitForStyle(String elementLocator, String styleText)
    Waits until the effective style of the element identified by the given element locator matches the given style.
    Parameters:
      `elementLocator` - the element locator
      `styleText` - the style that must match (e.g. `width: 10px; overflow: hidden;`)

  - ### waitForText

    void waitForText(String elementLocator, String text)
    Waits for the given text embedded in the given element.
    Parameters:
      `elementLocator` - locator identifying the element whose text should contain the given text
      `text` - the text to wait for

  - ### waitForTextPresent

    void waitForTextPresent(String text)
    Waits for the given text to appear.
    Parameters:
      `text` - the text to wait for

  - ### waitForTitle

    void waitForTitle(String title)
    Waits for the given page title.
    Parameters:
      `title` - the page title to wait for

  - ### waitForValue

    void waitForValue(String elementLocator, String value)
    Waits for the given value in the given element.
    Parameters:
      `elementLocator` - locator identifying the element whose value should match the given value
      `value` - the value to wait for

  - ### waitForVisible

    void waitForVisible(String elementLocator)
    Waits until the given element becomes visible.
    Parameters:
      `elementLocator` - the element locator

  - ### waitForXpathCount

    void waitForXpathCount(String xpath, int count)
    Waits for the number of elements matching the given XPath expression is equal to the given count.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements to wait for

  - ### waitForXpathCount

    void waitForXpathCount(String xpath, String count)
    Waits for the number of elements matching the given XPath expression is equal to the given count.
    Parameters:
      `xpath` - the XPath expression
      `count` - the number of elements to wait for